 
#define __STRICT_ANSI__ 1

#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <stdio.h>

#include <ezLicenseInfo.h>

//:
//:

void CALLING_CONVENTION ValidateLicenseKey(char* strLicenseKeyFileName)
{
    char strLicenseKey[ 100 * MAX_ENCRYPTED_LICENSE_TEXT_LENGTH ] = "";	
	char*	customKeyContext = "Dummy Key Context";
    FILE* fPtrLicenseKey = 0;
	char strReturnKey[MAX_ENCRYPTED_LICENSE_TEXT_LENGTH] = "";
	int iLicenseKeyCount = 0;
	int iDaysLeftThreshold = 0;
	int iQuotaUsageToDate = 0;
	int iQuotaThreshold = 0;
	int iDaysGracePeriod = 0;
	int iQuotaGrace = 0;
	int iCurrUsageValue = 0;
	const char* strUserHostName = "nehostuzer";

    if ((fPtrLicenseKey = fopen(strLicenseKeyFileName, "r")) == 0)
    {
        printf("\nError ! while opening licence key file");
        return;
    }

    fread(strLicenseKey, 100 * MAX_ENCRYPTED_LICENSE_TEXT_LENGTH, 1, fPtrLicenseKey);
	fclose(fPtrLicenseKey);

	//printf("\nLS :%s:\n", strLicenseKey);

	while (convertCSVFormatToPlain(strLicenseKey, strReturnKey) == 0)
	{
		//printf("\nstrReturnKey = %s", strReturnKey);
		int iWarningsBitMap = -1;
		int iWarningsBitMap1 = -1;
		
		printf("\nChecking License Key # %d:\n", ++iLicenseKeyCount);

		// Example of doing license key check with custom key handler

		printf("\n\tDoing full license key check:\n");

		void *
		ezLicInstance = allocLicenseInfo();

		iWarningsBitMap = checkLicenseKey(ezLicInstance,
							  strReturnKey,
							  customKeyHandler,
							  customKeyContext,
							  iDaysLeftThreshold,
							  iQuotaUsageToDate,
							  iQuotaThreshold,
							  iDaysGracePeriod,
							  iQuotaGrace,
							  strUserHostName, 
							  iCurrUsageValue);

		
		if (iWarningsBitMap >= 0) {
			// success / success w/ warning
			displayLicenseParams(ezLicInstance, "");
			checkWarnings(iWarningsBitMap, "");
			printf("\n\t\tFull license key check successful.\n"); 
		} else
			checkErrors(iWarningsBitMap);
		freeLicenseInfo(ezLicInstance);
//:
//:
	}	
}

   

// Sample custom key handler that does nothing useful.  Do your
// MAC address check etc. here, return 0 if success, +ve warning
// bitmap if success with warning, and -ve error code if error.

int customKeyHandler(void *keyCtx, 
					const char *strCustomKey)
{
	char *ctxStr = (char *)keyCtx;
	if (keyCtx != 0)
		printf("\n\t\tCustom key handler: key context string is: %s", ctxStr);
	if (strCustomKey != 0)
		printf("\n\t\tCustom key handler: custom key string is: %s",
				strCustomKey);
	return 0;
}

